%define name proftpd
%define version 1.2.0rc2
%define release 7mdk

Name:		%{name}
Summary:	ProFTPd -- Professional FTP Server.
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		System/Servers
URL:		http://www.proftpd.net/
Source:		ftp://ftp.proftpd.net/pub/proftpd/%{name}-%{version}.tar.bz2
Source1:	%{name}.logrotate
Source2: 	proftpd.xinetd
Requires:	pam >= 0.59, chkconfig
Provides:	ftpserver
Conflicts:	wu-ftpd, ncftpd, beroftpd, anonftp
Prereq:		fileutils
BuildRoot:	%{_tmppath}/%{name}-%{version}


%description
ProFTPd is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration.  It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This package will setup ProFTPd for both inetd and standalone operations.


%prep
%setup -q


%build
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
mkdir -p %{buildroot}

##% configure --localstatedir=/var/run --with-modules=mod_linuxprivs:mod_ratio:mod_readme:mod_pam
./configure --prefix=%{_prefix} \
  --sysconfdir=%{_sysconfdir} \
  --localstatedir=/var/run \
  --with-modules=mod_linuxprivs:mod_ratio:mod_readme:mod_pam:mod_quota \
  --enable-autoshadow

make CFLAGS="$RPM_OPT_FLAGS"


%install
myname=`id -un`
mygroup=`id -gn`

%makeinstall localstatedir=%{buildroot}/var/run rundir=%{buildroot}/var/run/proftpd INSTALL_USER=$myname INSTALL_GROUP=$mygroup

mkdir -p %{buildroot}/{home/ftp,%{_sysconfdir}/{pam.d,logrotate.d},%{_initrddir}}

mkdir -p %{buildroot}%{_sysconfdir}/xinetd.d

install -m644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/ftp
install -m644 sample-configurations/basic.conf %{buildroot}%{_sysconfdir}/proftpd.conf
install -m755 contrib/genuser.pl %{buildroot}%{_sbindir}
install -m755 contrib/xferstats.holger-preiss %{buildroot}%{_sbindir}
install -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/proftpd
install -m755 %{SOURCE2} %{buildroot}%{_sysconfdir}/xinetd.d/proftpd

touch %{buildroot}%{_sysconfdir}/ftpusers

mkdir -p %{buildroot}%{_initrddir}

sed	-e '/FTPSHUT=/c\' \
	-e 'FTPSHUT=%{_sbindir}/ftpshut' \
	contrib/dist/rpm/proftpd.init.d \
> contrib/dist/rpm/proftpd.init.d.tmp

install -m755 contrib/dist/rpm/proftpd.init.d.tmp %{buildroot}%{_initrddir}/proftpd

chmod 511 %{buildroot}%{_sbindir}/proftpd

ln -sf proftpd %{buildroot}%{_sbindir}/in.proftpd
ln -sf proftpd %{buildroot}%{_sbindir}/in.ftpd

echo "root" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "bin" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "daemon" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "adm" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "lp" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "sync" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "shutdown" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "halt" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "mail" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "news" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "uucp" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "operator" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "games" >> %{buildroot}%{_sysconfdir}/ftpusers
echo "nobody" >> %{buildroot}%{_sysconfdir}/ftpusers

mkdir -p %{buildroot}/var/log/proftpd
mkdir -p %{buildroot}/var/ftp/pub

%pre
if [ -f /var/lock/subsys/proftpd ]; then
  %{_initrddir}/proftpd stop
fi


%post

# This is a mess.
/sbin/chkconfig --add proftpd


# Check if system uses inetd.conf for ftp service
# Look if there is already an entry for 'ftp' service even when commented.

  tmpfile=/tmp/proftpd-inetd#.$$
  grep -v '^[#[:space:]]*ftp'  /etc/inetd.conf > $tmpfile && \
  mv --force $tmpfile %{_sysconfdir}/inetd.conf || \
  # Not found, append a new entry, comment by default
  echo '#ftp      stream  tcp     nowait  root    /usr/sbin/tcpd  in.proftpd' >> %{_sysconfdir}/inetd.conf
# Reread 'inetd.conf' file.
killall -HUP inetd || :


%preun
if [ $1 = 0 ]; then
  if [ -f /var/lock/subsys/proftpd ]; then
   %{_initrddir}/proftpd stop
 fi
 if [ -d /var/run/proftpd ]; then
  rm -rf /var/run/proftpd/*
fi
/sbin/chkconfig --del proftpd
fi


%postun
# Remove ProFTPD entry from %{_sysconfdir}/inetd.conf
tmpfile=/tmp/proftpd-inetd.$$
sed -e '/^.*proftpd.*$/d' %{_sysconfdir}/inetd.conf > $tmpfile
mv --force $tmpfile %{_sysconfdir}/inetd.conf

# Quick hack to add back the entry fot wu et al.
# we won't need this for long, when we move to xinetd fully then we gonna
#remove this.

grep 'in.ftpd' /etc/inetd.conf || \
echo "ftp stream tcp nowait root /usr/sbin/tcpd in.ftpd -l -a" >> /etc/inetd.conf

killall -HUP inetd || :

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}


%files
%defattr(-,root,root)
%doc README* ChangeLog INSTALL NEWS CREDITS COPYING doc/* contrib/README*
%doc sample-configurations/*
%attr(600,root,root) %config(noreplace) %{_sysconfdir}/proftpd.conf
%config(noreplace) %{_sysconfdir}/ftpusers
%config(noreplace) %{_sysconfdir}/pam.d/ftp
%config(noreplace) %{_initrddir}/proftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/proftpd
%{_sbindir}/*
%{_bindir}/*
%{_mandir}/man1/ftpwho.1*
%{_mandir}/man1/ftpcount.1*
%{_mandir}/man5/xferlog.5*
%{_mandir}/man8/proftpd.8*
%{_mandir}/man8/ftpshut.8*
%dir /var/run/proftpd
%dir /var/log/proftpd
%attr(0755,ftp,ftp) %dir /var/ftp
%attr(2755,ftp,ftp) %dir /var/ftp/pub


%changelog
* Wed Sep 27 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-7mdk
- really fix inetd problem. We remnove it from /etc/inetd.conf, and let it
  run instandalone mode which seems to work quite fine ...

* Fri Sep 22 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-6mdk
- really add the xinetd entry.

* Thu Sep 21 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-5mdk
- include the chkconfig entry, but don't run chkconfig by default.
- add an xinetd entry.
- re-add the inetd.conf entry ... 

* Fri Sep 15 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-4mdk
- rebuild for the Big Move (tm) and hope that I don't break anything.
- remove inetd.conf entry (again, hoping that I don't break anything.)

* Tue Aug 29 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-3mdk
- use of _initrddir.

* Wed Aug 23 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-2mdk
- quick and ugly hack to fix wu-ftpd breakage when proftpd is uninstalled.
- change the description as the AUTH patch is no longer here.
 
* Sat Jul 29 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-1mdk
- new version
- remove the packager tag (vincentscks)

* Wed Jul 19 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-3mdk
- rebuild for directory changes

* Tue Jul 18 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-2mdk
- add directory /var/log/proftpd
- add home directory /home/ftp
- add conflicts with anonftp
- fix so can install as nonroot
- add --enable-autoshadow to configure

* Wed Jul 12 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-1mdk
- 1.2.0rc1
- macroization
- remove directory /home/ftp since we don't need it

* Fri Jun 30 2000 Vincent Danen <vdanen@linux-mandrake.com> 1.2.0pre10-2mdk
- merge with .spec file from Geoffrey Lee <snailtalk@linux-mandrake.com>:
- add logrotate entry
- add symlinks to in.proftpd and in.ftpd
- on uninstall, run /etc/rc.d/init.d/proftpd stop prior to uninstall
- compile with mod_pam support
- add Conflicts: wu-ftpd, ncftpd, beroftpd

* Fri May  5 2000 Vincent Danen <vdanen@linux-mandrake.com> 1.2.0pre10-1mdk
- build for Mandrake
- bzip sources
- bzip manpages
- remove multi-package creation.  one package does all... updates
  /etc/inetd.conf but defaults to standalone server type

* Thu Oct 3 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 8 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.
